// ermes4c do some minor changes on dec.4 1998.
// also some color and blue statusline.

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <dir.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <bios.h>

//
// ERMES program source code 4c. dec.1998.
//

/* global variables */

// PROGRAM OPTION DEFAULT SETTINGS...
static unsigned int rcvpolarity = 0;    // 1 means invert rcv signal
static unsigned int sport       = 1;    // default com port

static int hups = 0;

FILE *out;                              // pointer to output file
static char fname[20]={"ERMESXXXXXX"};  // regular log file name

// serial port registers addresses... (initialized on startup)
static unsigned int comrxtx,comier,comiir,comdfr,commcr,comssr,commsr;

static unsigned int buflen= 10000;      /* length of data buffer      */
static volatile unsigned int cpstn = 0; /* current position in buffer */
static unsigned int  fdata[10001] ;     /* frequency data array       */
static unsigned char ldata[10001] ;
static volatile unsigned int  imalive=0;// imalive flag for com interrupt

char block[300];
char ob[1000];
static unsigned int ltick=0x0000;

static double rcver[65];		// rcv clock error ring buf
static int   ircver=0;
static double exc=0.0;

// receive symbol clock tightness - lower numbers mean slower loop response
static double rcv_clkt = 0.035;         // rcv loop clock tightness
//static double rcv_clkt_hi = 0.065;	// coarse rcv clock (sync ups only)
//static double rcv_clkt_lo = 0.020;      // fine rcv clock (data)

// contains pocsag numeric paging data format

// spinner doohickey characters: /  \ -

static char spin1[4]={47,179,92,'-' };

// this table translates received modem status line combinations into
// the received symbol;
static int rcv[16]=
{

// this line gives number of high status lines
	0, 1, 1, 2, 0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3

};

//**********************************************************************

// error detection / correction matrix
int gmat[18]={
	0xF08, 0x784, 0x3C2, 0x1E1,
	0xD96, 0x6CB, 0xE03, 0xA67,
	0x855, 0x94C, 0x4A6, 0x253,
	0xC4F, 0xB41, 0x8C6, 0x463,
	0xF57, 0xACD
};

/* address field terminating word */
long int apt = 0x09C461C9l;

/* message delimiter */
long int mdel = 0x3777E7ABl;

/* syndrome lookup table - indicates whether errors have occured;  */
/* if so it gives location of bad bits if errors are correctable   */
int syndlup[4096];

/* array used to hold bits for de-interleaving */
static int fin[300];




//-------------------------------------------------------------------------

void interrupt (*oldfuncc) (...); /* vector to old com port interrupt    */

void interrupt (*oldtimer) (...); // vector to original system timer int.

// This interrupt is called whenever one of the modem status lines changes.
// it stores the elapsed time since the last change in array fdata[] and the
// number of status lines that were high for that time period in ldata[].
// This interrupt handler can get hung up if a second modem status line
// changes state while this routine is processing... The com port will then
// have issued a second IRQ that is missed by this routine, and no further
// interrupts come in from the com port since it's still waiting for the
// missed interrupt to be serviced.The system timer interrupt is used as
// a lame workaround (see interrupt service routine newtimer).
// Why is it in assembly? hopefully so it runs just a little faster...
// but if you look at the executable code you find that a sizable portion
// of this handler is involved with pushing and popping the complete
// processor state onto and off of the stack.
void interrupt com1int(...)
{
	static unsigned int dtick,k;

	asm{
		XOR al,al;		// latch system timer and read it out
		OUT 0x43,al;
		IN 	al, 0x40;
		ROL ax, 0x08;
		in 	al, 0x40;
		ROL ax, 0x08;

		mov bx, ltick;      // subtract off previous count, place in dtick
		mov ltick, ax;
		sub bx, ax;
		mov dtick, bx;

		xor ax,ax;          // reset imalive flag
		mov imalive,ax;

	};



	// guess I'm to lazy to code this in assembly now...
	fdata[cpstn] = dtick;        /* put freq in fdata array             */
	ldata[cpstn] = k;

	cpstn  ++;                   /* increment data buffer pointer       */
	if (cpstn>buflen) cpstn=0;   /* make sure cpstn doesnt leave array  */

	asm{
		mov dx, comiir;     // clear IIR
		in	al, dx;
		mov dx, comssr;
		in 	al, dx;

		mov dx, commsr;     // this clears interrupt on serial port
		in	al, dx;
		and ax, 0x00ff;
		mov k , ax;

		mov al, 0x20;	// issue general end of interrupt to PIC
		out 0x20, al;
	};
}

// new timer interrupt - purpose is to check if above ISR is hung
// every time timer rolls over (every 55 milliseconds); also turns
// beep off after appropriate length of time
void interrupt newtimer(...)
{
	static int t;

	// if imalive flag hasn't been reset in one whole clock tick
	// then we may have screwed the pooch.
	if (imalive != 0)
	{
		// Make sure we actually have a pending interrupt by reading iir.
		// Otherwise a long period where the input lines do not change
		// (as may happen when transmitter turns on/off and level sensing
		// circuitry hasn't had enough time to readjust) would cause the
		// hangup counter to jump.
		if (inportb(comiir) == 0)
		{
			// at this point: we've been screwed up for one whole cycle plus
			// the time indicated in ltick. So we attempt to make up for
			// this lost time in the RCV data buffer; hopefully letting
			// us continue processing the rest of any messages being received

			hups++;			// provide visual indicator of screwups
			t = ( hups      & 0x0f) + 48;
			if (t > 57) t+= 7;
			pokeb(0xb800,156,t);
			t = ((hups>>4 ) & 0x0f) + 48;
			if (t > 57) t+= 7;
			pokeb(0xb800,154,t);
			t = ((hups>>8 ) & 0x0f) + 48;
			if (t > 57) t+= 7;
			pokeb(0xb800,152,t);
			t = ((hups>>12) & 0x0f) + 48;
			if (t > 57) t+= 7;
			pokeb(0xb800,150,t);

			fdata[cpstn] = ltick;       // this takes care of time in previous
			ldata[cpstn] = 0;           // cycle that was skipped
			cpstn  ++;
			if (cpstn>buflen) cpstn=0;

			fdata[cpstn] = 0xffff;      // this takes care of the clock tick
			ldata[cpstn] = 0;
			cpstn  ++;
			if (cpstn>buflen) cpstn=0;

			ltick = 0x0000;             // let com ISR restart from even keel

			inportb(commsr);             // start ball rolling again
		}
	}
	imalive = 666;

// important - turn sound off after count down has been reached
//  if (beepcntdn > 0)
//  {
//    beepcntdn--;
//    if (beepcntdn == 0)           DONT WANT TO HERE IT
//    {
//      t = inportb(0x61);
//      t = t & 0xFC;
//      outportb(0x61,t);
//    }
//  }

	oldtimer();                   // jump on to original timer interrupt
}

void set8250 ()                /* sets up the 8250 UART               */
{
	static unsigned int t;
	outportb (comdfr, 0x00);
	outportb (comier, 0x08);
	outportb (commcr, 0x0a);     /*  push up RTS, DOWN DTR              */
	t = inportb(comssr);         /*  clear LSR                          */
	t = inportb(comrxtx);        /*  clear RX                           */
	t = inportb(commsr);         /*  clear MSR                          */
	t = inportb(comiir);         /*  clear IID                          */
	t = inportb(comiir);         /*  clear IID - again to make sure     */
}

void set8253()                 /*  set up the 8253 timer chip         */
{                              /* NOTE: ctr zero, the one we are using*/
						 /*  is incremented every 840nSec, is   */
						 /*  main system time keeper for dos    */
	outportb (0x43, 0x34);       /* set ctr 0 to mode 2, binary         */
	outportb (0x40, 0x00);       /* this gives us the max count         */
	outportb (0x40, 0x00);
}


/****************************************************************/

int nones(int k)
{
	static int i,kt;
	kt = 0;
	for (i=0; i<=15; i++)
	{
		if ( (k & 0x0001) != 0) kt++;
		k = k >> 1;
	}
	return(kt);
}

int lones(long int k)
{
	static int i,kt;
	kt = 0;
	for (i=0; i<32; i++)
	{
		if ( (k & 0x0001l) != 0l) kt++;
		k = k >> 1;
	}
	return(kt);
}

/* this routine takes a raw codeword passed to it as parameter     */
/* col; does error correction & detection; and returns the bit     */
/* reversed data portion of the codeword as a long int.            */
/* The first 18 bits are the actual data; the second MSB is set    */
/* to indicate that the codeword contains uncorrectable errors.	   */
long int checkecc(long int col)
{
	static int ecc,i,j,nb,synd,tabe,nbb,bb;
	static int ts,ts2;
	static long int acw=0l;

	ecc = 0;
	synd = 0;
	acw = 0x00000l;
	for (i=0; i<18; i++)
	{
		acw = acw << 1;
		if ( (col & 0x01l) == 1)
		{
			ecc ^= gmat[i];
			acw = acw + 0x0001l;
		}
		col = col >> 1;
	}

	/* build up syndrome... */
	nb = 0;
	for (i=18; i<30; i++)
	{
		if ( (ecc & 0x800) != 0) ts  = 1; else ts  = 0;
		if ( (col & 0x01l) == 1) ts2 = 1; else ts2 = 0;
		ecc = ecc << 1;
		col = col >> 1;
		synd = synd << 1;
		if ( ts != ts2)
		{
			nb++;
			synd += 0x0001;
		}
	}
	synd = synd & 0x3fff;

	/* quick check - if no errors then we can return at once  */
	if (synd == 0x0000) return (acw);


	/* try to identify, correct errors */
	tabe = syndlup[synd];
	nbb = (tabe >> 14 ) & 0x03;
	if (nbb == 3)   /* uncorrectable errors are marked, kissed goodbye */
	{
		acw += 0x40000000l;
		return(acw);
	}

	/* at this point we have correctable errors somewhere in code word     */
	nbb = (tabe >> 12) & 0x03; /* get number of correctable errors in data */

	/* check if nothing to correct (all errors in syndrome) */
	if (nbb == 0) return (acw);

	/* at this point - we have at least one error in data, so correct it */
	bb = tabe & 0x003f;
	if (bb < 18)
	{
		acw = acw ^ (0x01l << bb);
	}
	else
	{
		/* we should never ever reach this point unless there is a   */
		/* serious problem somewhere...         			 */
		printf("\nOh my God, They've killed Kenny!... You Bastards!!!\n");
		printf("tabe = %i; bb = %i; synd = %04X \n",tabe,bb,synd);
		fprintf(out,"\nOh my God, They've killed Kenny!... You Bastards!!!\n");
		fprintf(out,"tabe = %i; bb = %i; synd = %04X \n",tabe,bb,synd);
	}

	/* we're finished if only one error in data needed to be corrected */
	if (nbb == 1) return (acw);

	/* Allright - so we have a second error in the data to correct */
	bb = (tabe >> 6) & 0x3f;
	if (bb < 18) acw = acw ^ (0x01l << bb);
	else
	{
		/* once again - should never reach this point */
		printf("\nError correction is really fubar...\n");
		printf("tabe = %i; bb = %i; synd = %04X \n",tabe,bb,synd);
		fprintf(out,"\nError correction is really fubar...\n");
		fprintf(out,"tabe = %i; bb = %i; synd = %04X \n",tabe,bb,synd);
	}

	/* two data errors corrected, no more processing to be done */
	return(acw);
}




/* This routine displays the message information. Each message has a  */
/* 36 bit header giving pager type (alpha / numeric / tone only);     */
/* message type (message fragment number, address reassignment, et    */
/* cetera), external operator identity, et cetera. I don't know the   */
/* structure of this header, so the full 36 bits are shown on screen, */
/* then the rest of the message is assumed to be alphanumeric text.   */
void showme(long int l, int c)
{
	static int nb=43,sl=0,i,ii;
	if (c == -1)
	{
		nb = 43;	/* initial holdoff 36 bits plus one 7 bit word */
//		printf("\n");
//    fprintf(out,"\n");      KEEP THE SCREEN CLEAN PLEASE
	}
	else
	{
		/* for now... indicate bad codeword with a '' */
		if ( l > 0x3fffffffl)
		{
//      printf("");         MISC MESSAGES, MOVE AWAY WE DONT NEED IT.
//      fprintf(out,"");
		}


		/* run through each data bit in the codeword */
		for (i=0; i<18; i++)
		{
			/* update shift register sl */
			sl = sl << 1;
			if ( (l & 0x20000l) != 0l) sl += 1;
			l = l << 1;

			/* hex dump 36 bit header */
			if ((nb > 7) && (nb < 42))
			{
	ii = nb >> 2;
	ii = ii << 2;
	if ( ii == nb)
	{
		sl = sl & 0x0f;
//	  printf("%1X",sl);
//    fprintf(out,"%1X",sl);
		sl = 0;
	}
	if (nb == 8)
	{
//		printf("; ");          DONT KNOW WHAT THIS IS
//		fprintf(out,"; ");
	}
			}

			nb--;

			/* if we're in message itself - collect 7 bits, print out character */
			if (nb == 0)
			{
	textcolor(15);
	textbackground(RED);
	nb = 7;
	sl = sl & 0x7f;
	cprintf ("%c",sl);        // THIS IS PUTTING THE DATA ON THE SCREEN !!!!!.
	fprintf (out,"%c",sl);
			}
		}
	}
}

/* this routine processes the raw stream of codewords, and it tries to */
/* pick out address & message information                              */
void docw(long int col, int blkc)
{
	static long int ecol;
	static int cycle, frame, batch, coco, opco, nadd=0, mess=0,done=0,lwd=0;
	static int ncbc = 0;

	/* if blkc is zero we must have gone on to a new batch */
	if (blkc == 0)
	{
//		textcolor(LIGHTGRAY);
		nadd = 0;
		mess = 0;
		done = 0;
		lwd  = 0;
		ncbc = 0;
//   		cprintf(" ");                DONT KNOW WHAT THIS IS
//			fprintf(out,"\n");
	}
		ecol = checkecc(col);

	/* code words 0 to 2 have misc information */
	if (blkc < 3)
	{
//		textcolor(RED);
//		cprintf(" %08lX ",ecol);         DONT NEED THIS PART
//		fprintf(out," %08lX ",ecol);
		if (blkc == 0)
		{
			if ( ecol < 0x40000000l )
			{
	opco = (int) ( (ecol >> 8)  & 0x07l);
	coco = (int) ( (ecol >> 11) & 0x7fl);
			}
		}
		else if (blkc == 1)
		{
			if ( ecol > 0x3fffffffl)
			{
	cycle = 666;
	frame = 666;
	batch = 666;
			}
			else
			{
	cycle = (int) ( (ecol >> 7) & 0x3fl);
	frame = (int) ( (ecol >> 4) & 0x07l);
	batch = (int) (  ecol & 0x0fl);
			}
		}
		if (blkc == 2)
		{
//      printf("  -->  CY/SS/BA : %02X/%02X/%02X",cycle,frame,batch);
//      fprintf(out,"  -->  CY/SS/BA : %02X/%02X/%02X",cycle,frame,batch);
//      THIS PART GIVING ALL KIND OF MISC INFO, DONT NEED THAT PART
		}
	}
	else
	{
		/* address and message fields code words come here */

		if (mess == 1)
		{

			/* count number of consequitive bad codewords */
			if ( ecol > 0x3fffffffl) ncbc++; else ncbc = 0;
			/* if this exceeds 4 assume we've lost sync  */
			if (ncbc > 4)
			{
				if (done == 0)
				{
//		printf("");                 DONT NEED THIS PART
//	  fprintf(out,"");
	}
	done = 1;
			}


			/* process message fields */
			if ((done == 0) && (blkc > 7))
			{

	if ( lones(col ^ mdel) < 4)
	{
		/* found message delimeter */

//		printf("(%i) ",blkc);        DONT NEED THIS PART.
//		fprintf(out,"(%i) ",blkc);
		if (lwd == 1) done = 1;
		lwd = 1;
		showme(ecol,-1);
	}
	else
	{
		lwd = 0;
		showme(ecol,0);
	}
			}


		}
		else
		{

			if ( lones(col ^ apt) < 4)
			{
	 /* we found address field delimeter */

//			printf("");                  DONT NEED THIS PART.
//			fprintf(out,"");
	mess = 1;
	/* check for no addresses */
	if (blkc == 3) done = 1;
	if (nadd == 0) done = 1;
	ncbc = 0;
			}
			else
			{

	/* we're in address field; we haven't found apt yet */

	if (ecol > 0x3fffffffl)
	{
		ncbc ++;
//		printf("\n(BAD) ");         DONT NEED THIS PART
//	  fprintf(out,"\n(BAD) ");
	}
	else
	{
		textcolor(LIGHTGREEN);        // DID SOME CHANGES HERE FOR BEETER VIEW
		textbackground(BLACK);        // THE MESSAGES I KNOW, STRANGE COLORS
		ncbc = 0;
		cprintf("\r\n    ADDRESS=");
		fprintf(out,"\n  ADDRESS=");
		if (ecol != 0x00l) nadd++;
		textcolor(14);
		textbackground(BLACK);
		cprintf("%011ld   SUB-ADDRESS=%08ld   FUNC=(%i)\r\n",col,ecol,blkc);
		fprintf(out,"%011ld   SUB-ADDRESS=%08ld   FUNC=(%i)\n",col,ecol,blkc);
		textcolor(LIGHTGRAY);
		textbackground(BLACK);
	}
/*	printf("FOUND ADDRESS %02i: %08lX   at blkc: %i\n",nadd,ecol,blkc); */
			}

/*      if (blkc > 6) */
			{
/*	mess = 1; */ /* <--- !!!!!!!!!  ************************************/
/*	if (nadd == 0) done = 1; else printf("\n3; "); */
			}
			/* if two consequitive bad address blocks... give up on this frame */
			if (ncbc >= 2)
			{

	mess = 1;
/*       done = 1; */
//	printf("");
//	fprintf(out,"");
			}
		}

	}

}

/* this routine processes the raw bit stream. Its output is a       */
/* steady stream of error corrected code words that are sent on for */
/* further processing to routine docw. It is synchronized by passing*/
/* -1 to the routine upon sync detection.                   	    */
/*                                                                  */
/* Processing: first 240 bits (8 codewords) are not interleaved...  */
/*             Afterwards codewords are interleaved in blocks of 9  */
void rawbit(int c)
{
	static int rbc = 0, blkc=0, iblk=0;
	static int ifin=0,l,ii,ij,il;
	static long int col;

	if (c == -1)	/* reset routine */
	{
		ifin = 0;
		rbc  = 0;
		iblk = 0;
		blkc = 0;
	}
	else
	{
		if (blkc >= 8)
		{
			/* collect, process interleaved code words */
			if (rbc < 16)  /* <---- !!!!! ****************************************/
			{
	fin[ifin] = c;
	ifin++;
	if (ifin >= 270)
	{
		for (ii=0; ii<9; ii++)
		{
			for (ij = 0; ij< 30; ij++)
			{
				il = (ij*9) + ii;
				col = col >> 1;
				if (fin[il] == '1') col += 0x20000000l;
			}

			docw(col,blkc);
			blkc++;
		}

		ifin = 0;
		rbc++;
	}
			}
		}
		else
		{
			/* process first eight non-interleaved code words */
			col = col >> 1;
			if ( c == '1' )  col += 0x20000000l;
			iblk++;
			if (iblk >= 30)
			{
	/* process the completed code word */
	docw(col,blkc);

	iblk = 0;
	blkc++;
			}
		}
	}

}

/* Set up syndrome lookup table for error detection/correction  */
/*                                                              */
/* each entry in syndlup[] is structured as follows:   		*/
/*     bits 15,14 give number of errors (3 = uncorrectable) 	*/
/*     bits 13,12 give number of data bits to correct           */
/*     bits 6-11 gives location of second error in data         */
/*     bits 0-5  gives location of first error in data          */
/*     if there are less than 2 bad bits in the data then 31    */
/*       is placed in bits 6-11 (and 0-5 if needed)             */
/*                                                              */
/* Note: bit numbers are reversed because the codeword is bit   */
/*       reversed in the checkecc routine (don't ask).          */
void setupecc()
{
	int i,j,k,l;

	/* first mark every possible syndrome as an uncorrectable error */
	for (i=0; i<4096; i++)  syndlup[i] = 0xCFFF;

	/* now mark first syndrome (0x000) as having no errors          */
	syndlup[0] = 0x0fff;

	/* mark single bit errors in data				  */
	for (i=0; i<18; i++)
	{
		k = 0x5FC0 + (17-i);  /* indicates 1 error in data at bit i   */
		l = gmat[i];
		syndlup[l] = k;
	}

	/* mark single bit errors in syndrome			 	*/
	for (i=0; i<12; i++)
	{
		k = 0x4FFF;      /* indicates 1 error, none in data */
		l = (0x01 << i);
		syndlup[l] = k;
	}

	/* mark double bit errors in data   */
	for (i=0; i<18; i++)
	{
		for (j=0; j<18; j++)
		{
			if (i != j)
			{
	/* two errors total; two correctable in data */
	k = 0xA000 + (17-i) + ((17-j) << 6);
	l = gmat[i] ^ gmat[j];
	syndlup[l] = k;
			}
		}
	}

	/* mark double errors in syndrome */
	for (i=0; i<12; i++)
	{
		for (j=0; j<12; j++)
		{
			if (i != j)
			{
	k = 0x8FFF;  /* two errors total; none in data */
	l = (0x01 << i) ^ (0x01 << j);
	syndlup[l] = k;
			}
		}
	}

	/* Finally: mark one error in syndrome; one error in data */
	for (i=0; i<18; i++)
	{
		for (j=0; j<12; j++)
		{
			k = 0x9FC0 + (17-i);   /* two errors total; one in data */
			l = gmat[i] ^ (0x01 << j);
			syndlup[l] = k;
		}
	}

}

// frame_ermes looks for 15 bit ermes sync; then sends the raw bit
// stream to routine rawbit for further processing.
void frame_ermes(int gin)
{
	static int ts=0,nh,st=0,bc=0,ss=0,lc=0,is=0;

	// sync sequence is 15 bits long
	ts = ts << 1;
	if ( (gin & 0x02) != 0) ts += 1;
	ts = ts & 0x7fff;

	if (st == 0)
	{
		// find number of mismatched bits
		nh = nones(ts ^ 0x5A67);

		// for test program only: make sure every bit in sync
		// matches up... otherwise we trigger pretty often off
		// random noise
		if (nh == 0)
		{
			// reset raw bit processing routine that
			rawbit(-1);

			// found sync, so now we'll try to process a raw batch
			// each batch is 3/4 of a second long or a little over 2300
			// symbols long
			st = 2300;
			bc = 0;
			lc = 0;
			is = 0;
		}
		else if (nh == 15)
		{
			bc = 0;
			lc = 0;

			// if we find inverted sync 5 times in a row then flip
			// receive polarity
			is++;
			if (is > 5)
			{

	is = 0;
	rcvpolarity ^= 0x01;
	printf("Flipped receive polarity\n");
	fprintf(out,"Flipped receive polarity\n");
			}
		}

	}
	else
	{
		// dump raw receive data - gin holds number of lines that are
		// high; this can be converted into two data bits (using a
		// gray code).
		if (gin > 1) rawbit (49); else rawbit(48);
		if ( (gin == 1) || (gin == 2)) rawbit (49); else rawbit(48);

		st--;
	}
}


void proc_arg(char ar[])
{
	static int te,tar;

	tar = ar[1];
	if ( tar > 64) tar = tar & 0x5f;      // convert char to upper case
	if ( ar[0] == '-') te = 0; else te = 1; // if minus sign disable option

	if (tar == 'P') rcvpolarity = te;

	// if first char is c - user is trying to specify a certain com port
	// with a number 1 to 4 as the second character
	if ( (ar[0] & 0x5f) == 'C')
	{
		sport = ar[1] - 48;
		// catch bogus com port settings
		if (sport < 1) sport = 1;
		if (sport > 4) sport = 1;
	}
}


void main (int argc, char *argv[] )
{
	unsigned int i=0,cw1=49,cw0=48,ldsr=0,dsr=0,ef=0,chh,lcw=0,du=0,lst=0;
	unsigned int n,irqv,comport;
	static double clk=0.0,rer=0.0,dt;
	int xpos,ypos,countertje;

	setupecc();

	for (du = 1; du<argc; du++)
	{
		proc_arg(argv[du]);
	}
	mktemp(fname);
	out = fopen(fname,"wt");
	if (out == NULL)
	{
		printf("Couldn't open output file so program terminated...\n\n");
		exit(1);
	}
	clrscr();

	textcolor(WHITE);
	textbackground(BLUE);
	cprintf ("\n\n");           //<-- should be spinning\r\n\n");
	textcolor(BLUE);
	textbackground(BLACK);
	cprintf (" =============================================================================\r\n");
	textcolor(BROWN);
	textbackground(BLACK);
	cprintf ("                          ERMES program 4c dec.1998 \r\n");
	textcolor(BLUE);
	textbackground(BLACK);
	cprintf (" =============================================================================\r\n\n");
	textcolor(15);
	textbackground(BLACK);
	cprintf ("       Command line options:\r\n");
//  printf ("       +P reverses receive data polarity\n");
	cprintf ("       C1, C2, C3, C4 tells which com port your interface is on.\r\n\n");
	textcolor(RED);
	textbackground(BLACK);
	cprintf ("                  You must use the 4 level FSK interface !\r\n\n");
	textcolor(15);
	textbackground(BLACK);
	cprintf ("       To use: let this program run during an active ERMES transmission.\r\n");
	cprintf ("       Caution: program won't stop by itself.\r\n");
	cprintf ("       To Stop: you must press Esc or the space bar.\r\n");
	cprintf ("       Original sourcecode is writen on May'98 by shrd_lu@hotmail.com.\r\n");
	cprintf ("       Put some color in it on dec.1998.\r\n");
	cprintf ("       Have lots of fun with this software.\r\n\n");
	textcolor(LIGHTGRAY);
	textbackground(BLACK);

	for (i=0; i<64; i++) rcver[i] = 0.0;

//  rcv_clkt = rcv_clkt_hi;

	// set rcv clock symbol rate to 3125 baud
	dt     =  1.0/(3125.0*838.8e-9);


	/* set up serial port and related parameters                          */
	n = inportb (0x21);
	if ( (sport == 1) | (sport == 3))
	{
		irqv = 0x0c;
		oldfuncc = getvect(irqv);    /* save COM  Vector                    */
		setvect (irqv, com1int);     /* Capture COM  vector                 */
		outportb(0x21, n & 0xef);
		if (sport == 1) comport = 0x3f8; else comport = 0x3e8;
	}
	else
	{
		irqv = 0x0b;
		oldfuncc = getvect(irqv);    /* save COM  Vector                    */
		setvect (irqv, com1int);     /* Capture COM  vector                 */
		outportb(0x21, n & 0xf7);
		if (sport == 2) comport = 0x2f8; else comport = 0x2e8;
	}

	// set up serial port register addresses
	comrxtx = comport;
	comier  = comport + 0x01;
	comiir  = comport + 0x02;
	comdfr  = comport + 0x03;
	commcr  = comport + 0x04;
	comssr  = comport + 0x05;
	commsr  = comport + 0x06;

	oldtimer = getvect(0x08);    // subvert system timer interrupt
	setvect (0x08, newtimer);

	set8253();                   /* set up 8253 timer chip              */

	set8250();                   /* set up 8250 UART                    */

	while (ef == 0)
	{
		if (i != cpstn)
		{
			clk += fdata[i];

			cw0 = ldata[i] >> 4;

			cw1 = rcv[cw0];

			// if in invert mode - invert both bits
			// This won't work with gray code, so rcv[] matrix must hold
			// number of status lines that are high
			if (rcvpolarity) cw1 ^= 0x03;

/* HERE I DID SOME MINOR CHANGES.
AND PUT IN THE STATUS LINE AND COLOR TAGS FOR IT.
YOU ONLY SEE STATUS LINE WHEN 4 LEVEL IS CONNECTED AND WORKING !!!!!!
*/
			// this shows that spinner thingie on the screen
			textcolor(WHITE);
			textbackground(BLUE);
			if ( cw1 == 3)
			{
			xpos=wherex();
			ypos=wherey();

			gotoxy(1,1);
			for(countertje=1;countertje<80;countertje++);//cprintf("");
			gotoxy (2,1);
			textcolor(WHITE);
			textbackground(BLUE);
			cprintf("\r ");
			textcolor(LIGHTRED);
			textbackground(BLUE);
			cprintf("<-should be spinning ");
			textcolor(WHITE);
			textbackground(BLUE);
			cprintf(" ERMES DECODER VERSION 4c 1998 ");
			textcolor(LIGHTRED);
			textbackground(BLUE);
			cprintf(" counter hangups->");
			textcolor(15);
			cprintf("");
//			textcolor(LIGHTRED);
//			textbackground(BLACK);
			cprintf("\r\n");
			textcolor(LIGHTGRAY);
			textbackground(BLACK);
			cprintf("                                                                                \r\n");
			gotoxy(xpos,ypos);
//			textcolor(LIGHTGRAY);
//			textbackground(BLACK);

	if (lst == 0)
	{
		du = (du+1) & 0x03;
		pokeb(0xb800,0x0000,spin1[du]);
	}
	lst = 3;
			}
			else if (cw1 == 0)
			{
	if (lst == 3)
	{
		du = (du+1) & 0x03;
		pokeb(0xb800,0x0000,spin1[du]);
	}
	lst = 0;
			}


//      xct = exc + 0.5 * dt;  /* exc is current boundary */
			while ( clk >= (exc + 0.5 * dt))
			{

	clk = clk - dt;

	frame_ermes(cw1);

	rcver[ircver] = rer;
	ircver++;
	if (ircver > 63) ircver = 0;
			}

			/* clk now holds new boundary position. update exc slowly... */
			/* for now only use center transitions to adjust rcv clock   */
			if ( cw1 > 1) dsr = 0; else dsr = 1;
			// was 0.02 ....
			rer = clk - exc;
			if (dsr != ldsr) exc = exc + rcv_clkt * (rer);
			ldsr = dsr;

			i++;
			if( i >buflen) i = 0;
		}

		// process keyboard commands
		if (kbhit() != 0)
		{
			chh = getch();
			if (chh == 32) ef++;
			else if (chh == 27) ef++;
		}

	}


	outportb (0x21, n);          /* disable IRQ  interrupt              */
	setvect (irqv, oldfuncc);    /* restore old COM  Vector             */
	setvect (0x08, oldtimer);    // restore original timer interrupt vector

	// And finally - disable serial port interrupt from reaching PIC.
	outportb(commcr,0x00);

	textcolor(LIGHTRED);
	textbackground(BLACK);
	cprintf("\n\n\r           HANGUP COUNTER : %04X \r\n",hups);
	fprintf(out,"\n  HANGUP COUNTER : %04X \n",hups);

	fclose(out);
	textcolor(15);
	textbackground(BLACK);
	cprintf("\n        Output data file : %s\r\n",fname);
	textcolor(LIGHTGRAY);
	textbackground(BLACK);
	cprintf("\r\n");
	textcolor(LIGHTGRAY);
	textbackground(BLACK);
}

